<ng-container *transloco="let t; prefix: 'onboardingTemplate'">
    <div class="d-flex px-2 min-vh-100 col-12 col-lg-12 flex-column gap-5 mt-5">
        <form [formGroup]="onboardingTemplateForm" id="onboardingTemplateForm" (ngSubmit)="onSubmit()"
            class="d-flex flex-column gap-2 row">
            <div class="col-12">
                <mat-form-field class="w-100" appearance="outline">
                    <mat-label>{{ t('templateDescription') }}</mat-label>
                    <input matInput formControlName="description" id="templateDescription" type="text" required
                        [placeholder]="t('templateDescriptionPlaceholder')">
                    @if (onboardingTemplateForm.get('description')?.invalid &&
                    (onboardingTemplateForm.get('description')?.dirty ||
                    onboardingTemplateForm.get('description')?.touched)) {
                    <mat-error>{{ t('required') }}</mat-error>
                    }
                </mat-form-field>
            </div>
            <div class="col-12 d-flex align-items-center">
                <div class="col-12 col-md-4">
                    <mat-form-field class="w-100" appearance="outline">
                        <mat-label>{{ t('expirationTimeframe') }}</mat-label>
                        <input matInput formControlName="expirationTimeframe" id="expirationTimeframe" type="number"
                            required min="0" max="15552000">
                        <mat-hint>
                            <span class="text-black-50">{{ t('expirationTimeframeHint') }}</span>
                        </mat-hint>
                    </mat-form-field>
                </div>
                <div class="col-12 col-md-8 align-items-center">
                    <span style="margin-left: 1rem;">{{expirationConversion}}</span>
                </div>
            </div>
            <lib-tabs class="mt-5" [tabs]="tabs"></lib-tabs>

            <ng-container formArrayName="documentTemplates">
                @for(documentTemplate of documentTemplates.controls; track documentTemplate;){
                <ng-container [formGroupName]="$index">
                    <div class="row border border-1 border-black p-2 m-2 gap-2 d-flex align-items-center">
                        <div class="row col-12">
                            <div class="col-12 col-md-6">
                                <mat-form-field class="w-100" appearance="outline">
                                    <mat-label>{{ t('name') }}</mat-label>
                                    <input matInput formControlName="name" required
                                        placeholder="{{ t('namePlaceholder') }}">
                                    @if(documentTemplate.get('name')?.invalid &&
                                    documentTemplate.get('name')?.touched){
                                    <mat-error>{{ t('required') }}</mat-error>
                                    }
                                </mat-form-field>
                            </div>

                            <div class="col-12 col-md-2">
                                <mat-form-field class="w-100" appearance="outline">
                                    <mat-label>{{ t('mimeType') }}</mat-label>
                                    <input type="text" placeholder="{{ t('mimeTypePlaceholder') }}" matInput
                                        formControlName="mimeType" [matAutocomplete]="auto"
                                        (input)="filterMimeTypes($event)" (focus)="filterMimeTypes()" required>
                                    <mat-autocomplete requireSelection #auto="matAutocomplete"
                                        [displayWith]="getMimeValue">
                                        @if(filteredMimeTypes.length > 0){
                                        @for (filteredMime of filteredMimeTypes; track filteredMime) {
                                        <mat-option [value]="filteredMime">{{filteredMime.value}}</mat-option>
                                        }
                                        } @else {
                                        <mat-option disabled>
                                            <span>{{ t('noMimeTypesAvailable') }}</span>
                                        </mat-option>
                                        <mat-option>
                                            <button type="button" (click)="insertMIMEType()" mat-raised-button
                                                class="w-100">{{ t('addMimeType') }}</button>
                                        </mat-option>
                                        }
                                    </mat-autocomplete>
                                    @if(documentTemplate?.get('mimeType')?.invalid &&
                                    documentTemplate?.get('mimeType')?.touched){
                                    <mat-error>{{ t('required') }}</mat-error>
                                    }
                                </mat-form-field>
                            </div>

                            <div class="col-12 col-md-2">
                                <mat-checkbox formControlName="mandatory">{{ t('mandatory') }}</mat-checkbox>
                            </div>

                            <div class="col-12 col-md-2">
                                <button mat-flat-button [matMenuTriggerFor]="menuRefs"
                                    aria-label="Example icon-button with a menu">
                                    <mat-icon>more_horiz</mat-icon>
                                </button>

                                <mat-menu #menuRefs="matMenu">
                                    <button type="button" mat-menu-item (click)="resetDocumentTemplate($index)">
                                        <mat-icon>settings_backup_restore</mat-icon>
                                        <span>{{ t('clear') }}</span>
                                    </button>
                                    @if($index > 0){
                                    <button type="button" mat-menu-item (click)="removeDocumentTemplate($index)">
                                        <mat-icon>delete</mat-icon>
                                        <span>{{ t('delete') }}</span>
                                    </button>
                                    }
                                </mat-menu>
                            </div>
                        </div>
                        <div class="row col-12">
                            <mat-form-field class="w-100" appearance="outline">
                                <mat-label>{{ t('description') }}</mat-label>
                                <input matInput formControlName="description" required
                                    placeholder="{{ t('descriptionPlaceholder') }}">
                                @if(documentTemplate.get('description')?.invalid &&
                                documentTemplate.get('description')?.touched){
                                <mat-error>{{ t('required') }}</mat-error>
                                }
                            </mat-form-field>
                        </div>
                    </div>
                </ng-container>
                }
            </ng-container>
            <div class="col-6 col-md-4">
                <button mat-flat-button color="accent" (click)="addDocumentTemplate()">
                    <mat-icon class="me-1">add</mat-icon>
                    {{ t('addDocumentTemplate') }}
                </button>
            </div>

            <div class="col-12 mt-5 d-flex gap-2">
                <div>
                    <button mat-stroked-button id="cancelButton" type="button" color="danger" [disabled]="loading"
                        (click)="onCancel()">
                        <span>{{ t('cancel') }}</span>
                    </button>
                </div>
                <div>
                    <button class="ml-3" mat-flat-button id="submitButton" type="submit" color="accent"
                        [disabled]="loading || !onboardingTemplateForm.valid">
                        <span>{{ t('save') }}</span>
                    </button>
                </div>
            </div>
        </form>
    </div>
</ng-container>